#!/usr/bin/perl
use strict;

if ($> != 0)
{
	print "Can only turn on or off iptables as root.\n";
	exit;
}

my $toggle = shift;
if ($toggle =~ /on|1/)
{
	turn_on_iptables();
}
else
{
	turn_off_iptables();
}

# there is a known issue, where VPN will stall and eventually timeout after changing iptables
restart_vpn();

exit;

sub turn_on_iptables
{
	my $resp = `/etc/init.d/iptables start`;
	if ($resp =~ /FAILED/i)
	{
		print $resp;
		return;
	}

	system("/sbin/chkconfig iptables on");
	print "SUCCESS\n";
}

sub turn_off_iptables
{
	my $resp = `/etc/init.d/iptables stop`;
	if ($resp =~ /FAILED/i)
	{
		print $resp;
		return;
	}

	system("/sbin/chkconfig iptables off");
	print "SUCCESS\n";
}

sub restart_vpn
{
	system("/etc/init.d/vpn stop");
	sleep 5;
	system("/etc/init.d/vpn start");
}

# Currently not debugging anything; but keeping for when doing so
sub dbg
{
	if (open my $l, '>>', '/tmp/iptables_enable.log')
	{
		print $l "@_\n";
		close $l;
	}
}
